﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DynamicRowAndCol_SectionReport
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private int index = 0;

        private void Form1_Load(object sender, EventArgs e)
        {
            for (; index < 10; )
            {
                clColumns.Items.Add(string.Format("第 {0} 列", ++index),true);
            }
        }
        
        private void btnAdd_Click(object sender, EventArgs e)
        {
            clColumns.Items.Add(string.Format("第 {0} 列", ++index),true);
        }

        private void btnRun_Click(object sender, EventArgs e)
        {
            DataTable dt = GetDataSource();
            SectionReport1 rpt = new SectionReport1();
            rpt.UnboundDataSource = dt;
            rpt.Document.Printer.PrinterName = "";

            viewer1.Document = rpt.Document;
            rpt.Run();
        }

        // 根据用户选择的列创建数据源
        private DataTable GetDataSource()
        {
            DataTable dt = new DataTable();
            foreach (var item in clColumns.CheckedItems)
            {
                dt.Columns.Add(item.ToString());
            }

            Random rdm = new Random();

            for (int i = 0; i < 10; i++)
            {
                DataRow row = dt.NewRow();

                foreach (DataColumn col in dt.Columns)
                {
                    row[col] = rdm.Next(10, 1000);
                }

                dt.Rows.Add(row);
            }

            return dt;
        }
    }
}
